<p align="center">
	<img width="763" src="https://cdn.rawgit.com/aharris88/awesome-cli-apps/master/media/banner.png" alt="awesome cli apps">
</p>

---

[![Awesome](https://cdn.rawgit.com/sindresorhus/awesome/d7305f38d29fed78fa85652e3a63e154dd8e8829/media/badge.svg)](https://github.com/sindresorhus/awesome)

> A curated list of command line apps.

Inspired by the [awesome](https://github.com/sindresorhus/awesome) list thing.

## Table of Contents

<!-- START doctoc generated TOC please keep comment here to allow auto update -->
<!-- DON'T EDIT THIS SECTION, INSTEAD RE-RUN doctoc TO UPDATE -->


- [Entertainment](#entertainment)
  - [Music](#music)
  - [Social Media](#social-media)
  - [Video](#video)
  - [Movies](#movies)
  - [Games](#games)
  - [Books](#books)
- [Development](#development)
  - [Text Editors](#text-editors)
  - [Web Development](#web-development)
  - [Mobile Development](#mobile-development)
  - [Database](#database)
  - [Devops](#devops)
  - [Docker](#docker)
  - [Release](#release)
  - [Npm](#npm)
  - [Boilerplate](#boilerplate)
- [Productivity](#productivity)
  - [Time Tracking](#time-tracking)
  - [Note Taking and Lists](#note-taking-and-lists)
  - [Finance](#finance)
  - [Presentations](#presentations)
  - [Calendars](#calendars)
- [Utilities](#utilities)
  - [macOS](#macos)
  - [Terminal Sharing Utilities](#terminal-sharing-utilities)
  - [Network Utilities](#network-utilities)
  - [Theming and Customization](#theming-and-customization)
  - [Shell Utilities](#shell-utilities)
  - [System Interaction Utilities](#system-interaction-utilities)
  - [Markdown](#markdown)
  - [Security](#security)
  - [Math](#math)
- [Command Line Learning](#command-line-learning)
- [Data Manipulation](#data-manipulation)
  - [Processors](#processors)
  - [JSON](#json)
  - [Columns](#columns)
  - [Text](#text)
- [Files and Directories](#files-and-directories)
  - [File Managers](#file-managers)
  - [Deleting, Copying, and Renaming](#deleting-copying-and-renaming)
  - [Files](#files)
  - [File Sync/Sharing](#file-syncsharing)
  - [Directory Listing](#directory-listing)
  - [Directory Navigation](#directory-navigation)
  - [Search](#search)
- [Version Control](#version-control)
  - [Git](#git)
  - [GitHub](#github)
- [Images](#images)
  - [Gif Creation](#gif-creation)
  - [Image Conversion](#image-conversion)
- [Screensavers](#screensavers)
- [Graphics](#graphics)
- [Just for Fun](#just-for-fun)
- [Other](#other)
  - [Emoji](#emoji)
- [Other Awesome Lists](#other-awesome-lists)
- [License](#license)

<!-- END doctoc generated TOC please keep comment here to allow auto update -->

---

## Entertainment

- [football-cli](https://github.com/ManrajGrover/football-cli) - Get live scores, fixtures, standings of almost every football competition/league.
- [pockyt](https://github.com/arvindch/pockyt) - Read, Manage, and Automate your [Pocket](https://getpocket.com) collection.
- [newsboat](https://github.com/newsboat/newsboat) - An extendable RSS feed reader for text terminals.

### Music

- [cmus](https://github.com/cmus/cmus) - Small, fast and powerful console music player.
- [Instant-Music-Downloader](https://github.com/yask123/Instant-Music-Downloader) - Instant music downloader.
- [itunes-remote](https://github.com/mischah/itunes-remote) - Control iTunes via CLI.
- [pianobar](https://6xq.net/pianobar/) - Pandora client.
- [somafm-cli](https://github.com/rockymadden/somafm-cli) - Listen to SomaFM in your terminal.
- [nehm](https://github.com/bogem/nehm) - Download tracks from SoundCloud.
- [mpd](https://github.com/MusicPlayerDaemon/MPD) - Music Player Daemon.
- [ncmpcpp](https://github.com/arybczak/ncmpcpp) - mpd client.
- [moc](http://moc.daper.net/) - Console audio player for Linux/UNIX.
- [musikcube](https://github.com/clangen/musikcube) - Cross-platform, terminal-based music player, audio engine, metadata indexer, and server.
- [beets](https://github.com/beetbox/beets) - Music library manager and tagger.
- [playx](https://github.com/NISH1001/playx) - Stream songs/playlists from various sources.
- [spotify-tui](https://github.com/Rigellute/spotify-tui) - Spotify client.
- [swaglyrics-for-spotify](https://github.com/SwagLyrics/SwagLyrics-For-Spotify) - Spotify lyrics.

### Social Media

- [facebook-cli](https://github.com/specious/facebook-cli) - Facebook command line interface.
- [TTYtter](https://github.com/oysttyer/oysttyer) - Twitter client.
- [Rainbowstream](https://github.com/DTVD/rainbowstream) - A smart and nice Twitter client on the terminal.
- [tuir](https://gitlab.com/ajak/tuir) - Reddit TUI.
- [WeeChat](https://weechat.org/) - Fast, light and extensible chat client.
- [irssi](https://github.com/irssi/irssi) - IRC chat client.
- [kirc](https://github.com/mcpcpc/kirc) - Tiny IRC client.

### Video

- [youtube-dl](https://github.com/ytdl-org/youtube-dl) - Download videos from YouTube.com and many other video sites.
- [streamlink](https://github.com/streamlink/streamlink) - Extract streams from various websites to a video player of your choosing.
- [mps-youtube](https://github.com/mps-youtube/mps-youtube) - Youtube player.
- [mpv](https://mpv.io) - Superior video player.
- [editly](https://github.com/mifi/editly) - Declarative video editing.

### Movies

- [moviemon](https://github.com/iCHAIT/moviemon) - Everything about your movies.
- [movie](https://github.com/mayankchd/movie) - Get movie info or compare movies.

### Games

- [Dwarf Fortress](http://www.bay12games.com/dwarves) - Roguelike construction and management simulation.
- [Cataclysm-DDA](https://cataclysmdda.org) - Turn-based survival game set in a post-apocalyptic world.

### Books

- [epr](https://github.com/wustho/epr) - epub reader.
- [Bible.Js CLI](https://github.com/BibleJS/BibleApp) - Bible.
- [SpeedRead](https://github.com/sunsations/speed_read) - Spritz-alike speedreader.
- [medium-cli](https://github.com/djadmin/medium-cli) - Read [medium.com](https://medium.com/) stories.

## Development

- [bcal](https://github.com/jarun/bcal) - Byte CALculator for storage conversions and calculations.
- [cgasm](https://github.com/bnagy/cgasm) - Gives x86 assembly documentation.
- [legit](https://github.com/captainsafia/legit) - Generate Open Source licences as files or file headers.
- [mklicense](https://github.com/cezaraugusto/mklicense) - Create a custom LICENSE file painlessly with customized info.
- [rebound](https://github.com/shobrook/rebound) - Fetch Stack Overflow results in your terminal when you get a compiler error.
- [bitwise](https://github.com/mellowcandle/bitwise) - Base conversion and bit manipulator in ncurses.
- [foy](https://github.com/zaaack/foy) - Lightweight general purpose task runner/build tool.
- [just](https://github.com/casey/just) - Modern `make`-like command runner.
- [grex](https://github.com/pemistahl/grex) - Generate regular expressions from user-provided test cases.
- [gdb-dashboard](https://github.com/cyrus-and/gdb-dashboard) - Modular visual interface for GDB.
- [iola](https://github.com/pvarentsov/iola) - Socket client with REST API.

### Text Editors

- [emacs](https://github.com/emacs-mirror/emacs) - An extensible, customizable, free/libre text editor — and more.
- [vim](https://github.com/vim/vim) - Vim - the ubiquitous text editor.
- [neovim](https://github.com/neovim/neovim) - Vim fork focused on extensibility and usability.
- [kakoune](https://github.com/mawww/kakoune) - Modal editor inspired by vim.
- [micro](https://github.com/zyedidia/micro) - A simple and intuitive editor.

### Web Development

- [caniuse-cmd](https://github.com/sgentle/caniuse-cmd) - Search [caniuse.com](caniuse.com) about browser support of feature.
- [is-up-cli](https://github.com/sindresorhus/is-up-cli) - Check whether a website is up.
- [pageres-cli](https://github.com/sindresorhus/pageres-cli) - Capture website screenshots.
- [strip-css-comments-cli](https://github.com/sindresorhus/strip-css-comments-cli) - Strip comments from CSS.
- [viewport-list-cli](https://github.com/kevva/viewport-list-cli) - Return a list of devices and their viewports.
- [surge](https://surge.sh) - Deploy a directory to the web.
- [loadtest](https://github.com/alexfernandez/loadtest) - Runs a load test on the selected URL. Easy to extend minimally for your own ends.
- [wp-cli](https://github.com/wp-cli/wp-cli) - Manage WordPress installations, update plugins, set up multisite installs and much more.
- [diff2html-cli](https://github.com/rtfpessoa/diff2html-cli) - Parse git diffs as JSON and generate pretty HTML.
- [HTTPie](https://github.com/jkbrzt/httpie) - A user-friendly HTTP client.
- [serve](https://github.com/zeit/serve) - Easy to use static file server with features like https, CORS and GZIP compression.
- [add-gitignore](https://github.com/TejasQ/add-gitignore) - Interactively generate a .gitignore for your project based on your needs.
- [Discharge](https://github.com/brandonweiss/discharge) - Deploy static websites to Amazon S3.
- [reachable](https://github.com/italolelis/reachable) - Check if a domain is up.
- [simplehttp](https://github.com/snwfdhmp/simplehttp) - Easily serve a local directory over http.
- [shell2http](https://github.com/msoap/shell2http) - Execute shell commands via HTTP server.
- [HTTP Prompt](https://github.com/eliangcs/http-prompt) - Interactive HTTP client featuring autocomplete and syntax highlighting.
- [ipfs-deploy](https://github.com/agentofuser/ipfs-deploy) - Deploy static websites to [IPFS](https://github.com/ipfs/ipfs#overviewhttps://github.com/ipfs/ipfs#overview).

### Mobile Development

- [mobicon-cli](https://github.com/SamVerschueren/mobicon-cli) - Mobile app icon generator.
- [mobisplash-cli](https://github.com/SamVerschueren/mobisplash-cli) - Mobile app splash screen generator.
- [deviceframe](https://github.com/c0bra/deviceframe) - Put device frames around your mobile/web/progressive app screenshots.

### Database

- [mycli](https://github.com/dbcli/mycli) - MySQL client with autocompletion and syntax highlighting.
- [pgcli](https://github.com/dbcli/pgcli) - Postgres client with autocompletion and syntax highlighting.
- [sqlline](https://github.com/julianhyde/sqlline) -  Shell for issuing SQL via JDBC.
- [iredis](https://github.com/laixintao/iredis) - Redis client with autocompletion and syntax highlighting.
- [usql](https://github.com/xo/usql) - Universal SQL client with autocompletion and syntax highlighting.

### Devops

- [htconvert](https://github.com/lukechilds/htconvert) - Convert .htaccess redirects to nginx.conf redirects.
- [SAWS](https://github.com/donnemartin/saws) - Supercharged AWS CLI.
- [s3cmd](https://github.com/s3tools/s3cmd) - Fully-Featured S3 client.
- [pm2](https://pm2.io/runtime/) - Production Process Manager for Node.js.
- [ops](https://github.com/nanovms/ops) - Unikernel compilation and orchestration tool.
- [flog](http://github.com/mingrammer/flog) - A fake log generator for log formats such as apache-common, apache error and RFC3164 syslog.
- [isitfit](http://github.com/autofitcloud/isitfit) - Manage AWS EC2 rightsizing.
- [k9s](https://github.com/derailed/k9s) - Manage Kubernetes Clusters.
- [PingMe](https://github.com/kha7iq/pingme) - Send messages/alerts to multiple messaging platforms & email.

### Docker

- [lstags](https://github.com/ivanilves/lstags) - Synchronize images across registries.
- [dockly](https://github.com/lirantal/dockly) - Interactively manage containers.
- [lazydocker](https://github.com/jesseduffield/lazydocker) - Simple docker/docker-compose interface.
- [docker-shell](https://github.com/Trendyol/docker-shell) - Simple interactive docker interface.
- [docker-pushrm](https://github.com/christian-korneck/docker-pushrm) - Push a readme to container registries.

### Release

- [release-it](https://github.com/webpro/release-it) - Automate releases for Git repositories and/or npm packages. Changelog generation, GitHub/GitLab releases, etc.
- [clog](https://github.com/clog-tool/clog-cli) - A conventional changelog for the rest of us.
- [np](https://github.com/sindresorhus/np) - A better `npm publish`.
- [release](https://github.com/zeit/release) - Generate changelogs with a single command.
- [semantic-release](https://github.com/semantic-release/semantic-release) - Fully automated version management and package publishing.

### Npm

- [npm-name-cli](https://github.com/sindresorhus/npm-name-cli) - Check whether a package name is available on npm.
- [npm-user-cli](https://github.com/sindresorhus/npm-user-cli) - Get user info of a npm user.
- [npm-home](https://github.com/sindresorhus/npm-home) - Open the npm page of the package in the current directory.
- [pkg-dir-cli](https://github.com/sindresorhus/pkg-dir-cli) - Find the root directory of a npm package.
- [npm-check-updates](https://github.com/tjunnone/npm-check-updates) - Find newer versions of package dependencies than what your package.json allows.
- [updates](https://github.com/silverwind/updates) - Flexible npm dependency update tool.
- [wipe-modules](https://github.com/bntzio/wipe-modules) - Remove `node_modules` of inactive projects.

### Boilerplate

- [yo](https://github.com/yeoman/yo) - Scaffolding tool for running Yeoman generators.
- [boilr](https://github.com/tmrts/boilr) - Create projects from boilerplate templates.
- [cookiecutter](https://github.com/audreyr/cookiecutter) - Create projects from templates.
- [mevn-cli](http://github.com/madlabsinc/mevn-cli) - Light speed setup for MEVN (Mongo Express Vue Node) Apps.
- [scaffold-static](https://github.com/jamesgeorge007/scaffold-static) - Scaffolding utility for vanilla JS.

## Productivity

- [AutoScreenshotUploader](https://github.com/yask123/AutoScreenshotUploader) - Capture and upload screenshots to imgur.
- [bitly-client](https://github.com/specious/bitly-client) - Bitly client.
- [doing](https://github.com/ttscoff/doing/) - Keep track of what you’re doing and track what you’ve done.
- [ffscreencast](https://github.com/cytopia/ffscreencast) - A ffmpeg screencast with video overlay and multi monitor support.
- [imgur-uploader-cli](https://github.com/kevva/imgur-uploader-cli) - Upload images to imgur.
- [meetup-cli](https://github.com/specious/meetup-cli) - Meetup.com client.
- [NeoMutt](https://neomutt.org) - Email client.
- [terjira](https://github.com/keepcosmos/terjira) - Jira client.
- [ipt](https://github.com/drselump14/ipt) - Pivotal Tracker client.
- [g3l](https://github.com/svtek/g3l) - Easiest git cli in the w0rld!
- [uber-cli](https://github.com/jaebradley/uber-cli) - Uber client.
- [Buku](https://github.com/jarun/Buku) - Browser-independent bookmark manager.
- [googler](https://github.com/jarun/googler) - Google from the terminal.
- [papis](http://github.com/alejandrogallo/papis) - Extensible document and bibliography manager.

### Time Tracking

- [Timetrap](https://github.com/samg/timetrap) - Simple timetracker.
- [moro](https://github.com/omidfi/moro) - Simple tool for tracking work hours.
- [Timewarrior](https://github.com/GothenburgBitFactory/timewarrior) - Utility with simple stopwatch, calendar-based backfill and flexible reporting.
- [Watson](https://github.com/TailorDev/Watson) - Generate reports for clients and manage your time.
- [utt](https://github.com/larose/utt) - Simple time tracking tool.

### Note Taking and Lists

- [idea](https://github.com/IonicaBizau/idea) - A lightweight tool for keeping ideas in a safe place quick and easy.
- [geeknote](https://github.com/jeffkowalski/geeknote) - Evernote client.
- [Taskwarrior](http://taskwarrior.org) - Manage your TODO list.
- [Terminal velocity](https://vhp.github.io/terminal_velocity/) - A fast note-taking app.
- [eureka](https://github.com/simeg/eureka) - Input and store your ideas.
- [sncli](https://github.com/insanum/sncli) - Simplenote client.
- [td-cli](https://github.com/darrikonn/td-cli) - A TODO manager to organize and manage your TODO's across multiple projects.
- [taskell](https://github.com/smallhadroncollider/taskell) - Interactive kanban board/task manager.
- [taskbook](https://github.com/klaussinani/taskbook) - Tasks, boards & notes for the command-line habitat.
- [dnote](https://github.com/dnote/dnote) - A interactive, multi-device notebook.
- [nb](https://github.com/xwmx/nb) - A note‑taking, bookmarking, archiving, and knowledge base application.

### Finance

- [ledger](http://ledger-cli.org) - Powerful, double-entry accounting system on the terminal
- [moeda](https://github.com/thompsonemerson/moeda) - Foreign exchange rates and currency conversion.
- [cash-cli](https://github.com/xxczaki/cash-cli) - Convert Currency Rates.
- [cointop](https://github.com/miguelmota/cointop) - Track cryptocurrencies.
- [ticker](https://github.com/achannarasappa/ticker) - Stock ticker.

### Presentations

- [WOPR](https://github.com/yaronn/wopr) - A simple markup language for creating rich terminal reports, presentations and infographics.
- [decktape](https://github.com/astefanutti/decktape) - PDF exporter for HTML presentations.
- [mdp](https://github.com/visit1985/mdp) - A command-line based markdown presentation tool.
- [sent](https://tools.suckless.org/sent/) - Simple plaintext presentation tool.

### Calendars

- [calcurse](http://calcurse.org/) - Calendar and scheduling.
- [gcalcli](https://github.com/insanum/gcalcli) - Google calendar client.
- [khal](https://github.com/pimutils/khal) - CalDAV ready CLI and TUI calendar.
- [vdirsyncer](https://github.com/pimutils/vdirsyncer) - CalDAV sync.
- [remind](https://dianne.skoll.ca/projects/remind) - A sophisticated calendar and alarm program.

## Utilities

- [archive-type-cli](https://github.com/kevva/archive-type-cli) - Detect archive type for a file or stdin.
- [s](https://github.com/zquestz/s) - Open a web search in your terminal.
- [aria2](https://github.com/tatsuhiro-t/aria2) - HTTP, FTP, SFTP, BitTorrent and Metalink download utility.
- [wego](https://github.com/schachmat/wego) - Get the weather.
- [weather-cli](https://github.com/riyadhalnur/weather-cli) - Check the weather.
- [mapscii](https://github.com/rastapasta/mapscii) - Terminal Map Viewer.
- [getnews.tech](https://github.com/omgimanerd/getnews.tech) - Fetch news headlines from various news outlets.
- [carbon-now-cli](https://github.com/mixn/carbon-now-cli) - Generate beautiful images of your code.
- [awesome-finder](https://github.com/mingrammer/awesome-finder) - Search the awesome lists without a browser.
- [shallow-backup](https://github.com/alichtman/shallow-backup) - Git integrated backup tool.

### macOS

- [open-pip-cli](https://github.com/albinekb/open-pip-cli) - Watch videos in picture-in-picture player.
- [app-path-cli](https://github.com/sindresorhus/app-path-cli) - Get the path to an app.
- [bundle-id-cli](https://github.com/sindresorhus/bundle-id-cli) - Get bundle identifier from a bundle name: Safari → com.apple.Safari.
- [bundle-name-cli](https://github.com/sindresorhus/bundle-name-cli) - Get bundle name from a bundle identifier: com.apple.Safari → Safari.
- [lnfs-cli](https://github.com/kevva/lnfs-cli) - Safely force create symlinks.
- [osx-version-cli](https://github.com/sindresorhus/osx-version-cli) - Get the macOS version.
- [osx-wifi-cli](https://github.com/danyshaanan/osx-wifi-cli) - Manage wifi connections.
- [active-win-cli](https://github.com/sindresorhus/active-win-cli) - Get the title/id/etc of the active window.
- [stronghold](https://github.com/alichtman/stronghold) - Configure security settings from the terminal.
- [website-popup-cli](https://github.com/sindresorhus/website-popup-cli) - Open a website in a popup.
- [dark-mode](https://github.com/sindresorhus/dark-mode) - Toggle dark mode.

### Terminal Sharing Utilities

- [gotty](https://github.com/yudai/gotty) - Share your terminal as a web application.
- [localtunnel](https://github.com/localtunnel/localtunnel) - Expose your localhost to the world for easy testing and sharing.
- [mosh](https://mosh.org/) - Remote SSH client that allows roaming with intermittent connectivity.
- [ngrok](https://ngrok.com/) - Secure introspectable tunnels to localhost.
- [serveo](https://serveo.net/) - Expose local servers to the internet using only a SSH client.
- [seashells.io](https://seashells.io/) - Pipe output to the web.
- [teleconsole](https://www.teleconsole.com/) - Share your UNIX terminal.
- [tmate](https://tmate.io/) - Instant terminal (tmux) sharing.
- [warp](https://github.com/spolu/warp) - Secure and simple terminal sharing.
- [OverTime](https://github.com/diit/overtime-cli) - Time-overlap tables for remote teams.

### Network Utilities

- [get-port-cli](https://github.com/sindresorhus/get-port-cli) - Get an available port.
- [is-reachable-cli](https://github.com/beatfreaker/is-reachable-cli) - Check if hostnames are reachable or not.
- [speedtest-net](https://github.com/ddsol/speedtest.net) - Test internet connection speed and ping using speedtest.net.
- [speed-test](https://github.com/sindresorhus/speed-test) - `speedtest-net` wrapper with different UI.
- [speedtest-cli](https://github.com/sivel/speedtest-cli) - Test internet bandwidth using speedtest.net.
- [bandwhich](https://github.com/imsnif/bandwhich) - Track bandwidth utilization by process.

### Theming and Customization

- [splash-cli](https://github.com/rawnly/splash-cli) - Beautiful wallpapers from Unsplash.
- [wallpaper-cli](https://github.com/sindresorhus/wallpaper-cli) - Get or set the desktop wallpaper.
- [themer](https://github.com/mjswensen/themer) - Generate personalized themes for your editor, terminal, wallpaper, Slack, and more.
- [JackPaper](https://github.com/jackel27/jackpaper) - Set images from Unsplash as wallpaper.
- [pywal](https://github.com/dylanaraps/pywal) - Generate and change color-schemes, then apply them system-wide to all of your favourite programs.
- [QuickWall](https://github.com/deepjyoti30/QuickWall) - Directly set wallpapers from Unsplash.

### Shell Utilities

- [has](https://github.com/kdabir/has) - Checks for the presence of various commands and their versions on the path.
- [Ultimate Plumber](https://github.com/akavel/up) - Write Linux pipes with live previews.
- [fkill-cli](https://github.com/sindresorhus/fkill-cli) - Simple cross-platform process killer.
- [task-spooler](http://vicerveza.homeunix.net/~viric/soft/ts) - Queue jobs for linear execution.
- [undollar](https://github.com/ImFeelingDucky/undollar) - Strip the '$' preceding copy-pasted terminal commands.
- [pipe_exec](https://github.com/koraa/pipe_exec) - Run executables from stdin, pipes and ttys without creating a temporary file.

### System Interaction Utilities

- [battery-level-cli](https://github.com/gillstrom/battery-level-cli) - Get current battery level.
- [brightness-cli](https://github.com/kevva/brightness-cli) - Change screen brightness ([windows](https://github.com/sondreb/win-brightness)).
- [yank](https://github.com/mptre/yank) - Yank terminal output to clipboard.
- [screensaver](https://github.com/gillstrom/screensaver) - Start the screensaver.
- [google-font-installer](https://github.com/lordgiotto/google-font-installer) - Download and install Google Web Fonts on your local machine.
- [neofetch](https://github.com/dylanaraps/neofetch) - System information tool.
- [Glances](https://nicolargo.github.io/glances) - System monitoring tool.

### Markdown

- [DocToc](https://github.com/thlorenz/doctoc) - Generates table of contents for markdown files.
- [grip](https://github.com/joeyespo/grip) - Preview markdown files as GitHub would render them.
- [mdv](https://github.com/axiros/terminal_markdown_viewer) - Styled terminal markdown viewer.

### Security

- [pass](https://www.passwordstore.org) - Password manager.
- [gopass](https://github.com/gopasspw/gopass) - Fully-featured password manager.
- [xiringuito](https://github.com/ivanilves/xiringuito) - SSH-based VPN.
- [acmetool](https://github.com/hlandau/acme) - Automatic certificate acquisition for ACME (Let's Encrypt).
- [certificate-ripper](https://github.com/Hakky54/certificate-ripper) - Extract server certificates.
- [ots](https://github.com/sniptt-official/ots) - Share secrets with others via a one-time URL.

### Math

- [mdlt](https://github.com/metadelta/mdlt) - Do quick math right from the command line.
- [Qalculate](https://github.com/Qalculate/libqalculate) - Calculate non-trival math expressions. Unit conversions, symbolic calculations and more.

## Command Line Learning

- [cmdchallenge](https://cmdchallenge.com) - Presents small shell challenge with user submitted solutions.
- [explainshell](http://www.explainshell.com) - Type a snippet to see the help text for each argument.
- [howdoi](https://github.com/gleitz/howdoi) - Instant coding answers.
- [how2](https://github.com/santinic/how2) - Node.js implementation of howdoi.
- [The Fuck](https://github.com/nvbn/thefuck) - Magnificent app which corrects your previous console command.
- [tldr](https://github.com/tldr-pages/tldr) - Simplified and community-driven man pages.
- [Wat](https://github.com/dthree/wat) - Instant, central, community-built docs.
- [teachcode](https://github.com/madlabsinc/teachcode) - Guide for the earliest lessons of coding.
- [navi](https://github.com/denisidoro/navi) - Interactive cheatsheet tool.

## Data Manipulation

- [visidata](https://github.com/saulpw/visidata) - Spreadsheet multitool for data discovery and arrangement.

### Processors

- [jq](https://github.com/stedolan/jq) - JSON processor.
- [yq](https://github.com/kislyuk/yq) - YAML processor.
- [dasel](https://github.com/tomwright/dasel) - JSON/YAML/TOML/XML processor (like jq/yq).
- [yaml-cli](https://github.com/pandastrike/yaml-cli) - Query/update YAML.
- [ramda-cli](https://github.com/raine/ramda-cli) - Process data with functional pipelines.

### JSON

- [jp](https://github.com/therealklanni/jp) - JSON parser.
- [fx](https://github.com/antonmedv/fx) - Command-line JSON viewer.
- [vj](https://github.com/busyloop/vj) - Makes JSON human readable.
- [underscore-cli](https://github.com/ddopson/underscore-cli) - Utility-belt for hacking JSON and Javascript.
- [strip-json-comments-cli](https://github.com/sindresorhus/strip-json-comments-cli) - Strip comments from JSON.
- [GROQ](https://github.com/sanity-io/groq-cli) – JSON processor with queries and projections.

### Columns

- [parse-columns-cli](https://github.com/sindresorhus/parse-columns-cli) - Parse text columns to JSON.
- [q](http://harelba.github.io/q/) - Execution of SQL-like queries on CSV/TSV/tabular text file.

### Text

- [figlet](http://www.figlet.org/) - Creates large text out of ASCII characters.
- [stegcloak](https://github.com/kurolabs/stegcloak) - Hide secrets with invisible characters in plain text securely.

## Files and Directories

### File Managers

- [ranger](https://github.com/ranger/ranger) - A console file manager with VI key bindings.
- [midnight-commander](https://github.com/MidnightCommander/mc) - A feature rich visual file manager.
- [Vifm](https://vifm.info/) - VI influnced file manager.
- [nnn](https://github.com/jarun/nnn) - File browser and disk usage analyzer with excellent desktop integration.
- [lf](https://github.com/gokcehan/lf) - Fast, extensively customizable file manager.
- [fff](https://github.com/dylanaraps/fff) - Fast, simple file manager.

### Deleting, Copying, and Renaming

- [trash-cli](https://github.com/sindresorhus/trash-cli) - Move files and directories to the trash.
- [empty-trash-cli](https://github.com/sindresorhus/empty-trash-cli) - Empty the trash.
- [del-cli](https://github.com/sindresorhus/del-cli) - Delete files and folders.
- [cpy-cli](https://github.com/sindresorhus/cpy-cli) - Copies files.
- [rename-cli](https://github.com/jhotmann/node-rename-cli) - Rename files quickly.
- [renameutils](https://www.nongnu.org/renameutils) - Mass renaming in your editor.
- [diskonaut](https://github.com/imsnif/diskonaut) - Disk space navigator.

### Files

- [chokidar-cli](https://github.com/kimmobrunfeldt/chokidar-cli) - CLI to watch file system changes.
- [file-type-cli](https://github.com/sindresorhus/file-type-cli) - Detect the file type of a file or stdin.
- [bat](https://github.com/sharkdp/bat) - A cat clone with syntax highlighting.
- [NCDu](https://dev.yorhel.nl/ncdu) - A disk usage analyzer with an ncurses interface.
- [unix-permissions](https://github.com/ehmicky/unix-permissions) - Swiss Army knife for Unix permissions.
- [transmission-cli](https://transmissionbt.com) - Torrent client for your command line.
- [webtorrent-cli](https://github.com/feross/webtorrent-cli) – Streaming torrent client.
- [entr](https://github.com/eradman/entr) - Run an arbitrary command when files change.
- [organize-cli](https://github.com/ManrajGrover/organize-cli) - Organize your files automatically.
- [organize-rt](https://gitlab.com/FixFromDarkness/organize-rt) - organize-cli in Rust with more customization.
- [RecoverPy](https://github.com/PabloLec/RecoverPy) - Recover overwritten or deleted files.

### File Sync/Sharing

- [rclone](https://github.com/ncw/rclone) - Sync files with various cloud providers.
- [ffsend](https://github.com/timvisee/ffsend) - Quick file share.
- [share-cli](https://github.com/marionebl/share-cli) - Share files with your local network.
- [google-drive-upload](https://github.com/labbots/google-drive-upload) - Upload/sync with Google Drive.
- [gdrive-downloader](https://github.com/Akianonymus/gdrive-downloader) - Download files/folders from Google Drive.

### Directory Listing

- [alder](https://github.com/aweary/alder) - Minimal `tree` with colors.
- [exa](https://github.com/ogham/exa) - Improved version of `ls`.
- [tre](https://github.com/dduan/tre) - `tree` with git awareness, editor aliasing, and more.
- [ll](https://github.com/antonmedv/ll) - `ls` with git status.

### Directory Navigation

- [autojump](https://github.com/wting/autojump) - A cd command that learns - easily navigate directories from the command line.
- [fasd](https://github.com/clvv/fasd) - Command-line productivity booster, offers quick access to files and directories, inspired by autojump, z and v.
- [pm](https://github.com/Angelmmiguel/pm) - The easy way to switch to your projects on the shell.
- [z](https://github.com/rupa/z) - z is the new j, yo.
- [PathPicker](https://github.com/facebook/pathpicker/) - After parsing the output from a command, PathPicker presents you with a nice UI to select which files you're interested in.
- [fz](https://github.com/changyuheng/fz) - Seamless fuzzy tab completion for z.
- [goto](https://github.com/iridakos/goto) - Directory aliases for the shell with autocomplete.
- [z.lua](https://github.com/skywind3000/z.lua) - `cd` command that learns your habits.
- [zoxide](https://github.com/ajeetdsouza/zoxide) - Fast directory jumper in Rust.

### Search

- [happyfinder](https://github.com/hugows/hf) - (another) Fuzzy file finder for the command line.
- [find-up-cli](https://github.com/sindresorhus/find-up-cli) - Find a file by walking up parent directories.
- [ripgrep](https://github.com/BurntSushi/ripgrep) - A line-oriented search tool that recursively searches your current directory for a regex pattern.
- [fzf](https://github.com/junegunn/fzf) - A general purpose command-line fuzzy finder, can be used with any list: files/directories, command history, processes, hostnames, bookmarks, git commits, etc.
- [fselect](https://github.com/jhspetersson/fselect) - Find files with SQL-like queries.
- [fd](https://github.com/sharkdp/fd) - A simple, fast and user-friendly alternative to `find`.
- [broot](https://github.com/Canop/broot) - Fuzzy finder similar to fzf, but with space usage visualization.
- [rare](https://github.com/zix99/rare) - Real-time regex aggregation and analysis.

## Version Control

- [SnowFS](https://github.com/snowtrack/snowfs) - A fast, scalable version control system for binaries.

### Git

- [git commander](https://github.com/golbin/git-commander) - Interactive git tool.
- [git-stats](https://github.com/IonicaBizau/git-stats) - A local GitHub-like contributions calendar.
- [dev-time](https://github.com/samverschueren/dev-time-cli) - Get the current local time of a GitHub user.
- [tig](https://github.com/jonas/tig) - Text-mode interface for git.
- [grv](https://github.com/rgburke/grv) - Text-mode interface for git with customisable vi bindings.
- [git-standup](https://github.com/kamranahmedse/git-standup) - Recall what you did on the last working day.
- [git-secret](https://github.com/sobolevn/git-secret) - Store your private data inside a git repository.
- [gitlab-cli](https://github.com/vishwanatharondekar/gitlab-cli) - Create GitLab merge requests.
- [git-extras](https://github.com/tj/git-extras) - Git utilities.
- [gita](https://github.com/nosarthur/gita) - Manage multiple git repos side by side.
- [readme-md-generator](https://github.com/kefranabg/readme-md-generator) - Interactively generate README.md files.
- [semantic-git-commit-cli](https://github.com/JPeer264/node-semantic-git-commit-cli) - Ensure semantic commits messages.
- [import-github-labels-cli](https://github.com/abhijithvijayan/import-github-labels-cli) - Sync labels between Github repos.
- [git-all-branches](https://github.com/zacanger/git-all-branches) - Improved `git branch -a`.

### GitHub

- [CLI GitHub](https://github.com/IonicaBizau/cli-github) - Fancy GitHub client.
- [Gistup](https://github.com/mbostock/gistup) - Manage GitHub gists.
- [hub](https://github.com/github/hub) - Make git easier to use with GitHub.
- [git-labelmaker](https://github.com/himynameisdave/git-labelmaker) - Edit GitHub labels.

## Images

- [SVGO](https://github.com/svg/svgo) - Optimize SVG files.

### Gif Creation

- [gifgen](https://github.com/lukechilds/gifgen) - Simple high quality GIF encoding.
- [gifsicle](https://github.com/kohler/gifsicle) - Create, manipulate, and optimize GIF images and animations.
- [ttygif](https://github.com/icholy/ttygif) - Convert terminal recordings to animated gifs.
- [ttygif](https://github.com/sugyan/ttygif) - ttyrec to gif.
- [ttystudio](https://github.com/chjj/ttystudio) - A terminal-to-gif recorder minus the headaches.
- [asciinema](https://github.com/asciinema/asciinema) - Terminal session recorder and companion app for asciinema.org.
- [givegif](https://github.com/passy/givegif) - GIFs on the command line.

### Image Conversion

- [imagemagick](https://imagemagick.org) - Gold standard for anything images.
- [imgp](https://github.com/jarun/imgp) - Blazing fast batch image resizer and rotator.
- [korkut](https://github.com/oguzhaninan/korkut) - Quick and simple image processing.

## Screensavers

- [cmatrix](https://github.com/Treri/cmatrix) - Scrolling 'Matrix'-like screen.
- [pipes.sh](https://github.com/pipeseroni/pipes.sh) - Random pipes that grow across the screen.
- [YuleLog](https://github.com/Duroktar/YuleLog) - Christmas Yule Log fireplace.
- [cli-fireplace](https://github.com/dolsup/cli-fireplace) - Digital fireplace.

## Graphics
- [cli-mandelbrot](https://github.com/danyshaanan/cli-mandelbrot) - Traverse the Mandelbrot fractal.
- [sparkly-cli](https://github.com/sindresorhus/sparkly-cli) - Generate sparklines ▁▂▃▅▂▇..
- [pastel](https://github.com/sharkdp/pastel) - Generate, analyze, convert and manipulate colors.
- [lowcharts](https://github.com/juan-leon/lowcharts) - Draw low-resolution graphs.

## Just for Fun

- [cowsay](https://github.com/tnalpgge/rank-amateur-cowsay) - A configurable talking cow (and other animals).
- [quote-cli](https://github.com/riyadhalnur/quote-cli) - Get a random quote or the quote of the day in your CLI.
- [fortune](https://github.com/shlomif/fortune-mod) - Shows a random fortune.
- [ponysay](https://github.com/erkin/ponysay) - Pony rewrite of cowsay.
- [yosay](https://github.com/yeoman/yosay) - Like cowsay, but for yeoman.
- [lolcat](https://github.com/busyloop/lolcat) - Outputs text in rainbow colors.
- [text-meme](https://github.com/beatfreaker/text-meme-cli) - Generate text memes.
- [dankcli](https://github.com/sggts04/dankcli) - Add text to meme image templates.
- [ricksay](https://github.com/roma-guru/ricksay) - Quotes from Rick and Morty.

## Other

- [birthday](https://github.com/IonicaBizau/birthday) - Know when a friend's birthday is coming.
- [detect-indent-cli](https://github.com/sindresorhus/detect-indent-cli) - Detect the indentation of code.
- [fullname-cli](https://github.com/sindresorhus/fullname-cli) - Get the fullname of the current user.
- [gzip-size-cli](https://github.com/sindresorhus/gzip-size-cli) - Get the gzipped size of a file.
- [HASHA -cli](https://github.com/sindresorhus/hasha-cli) - Hashing made simple. Get the hash of text or stdin.
- [kill-tabs](https://github.com/sindresorhus/kill-tabs) - Kill all Chrome tabs to improve performance, decrease battery usage, and save memory.
- [leven-cli](https://github.com/sindresorhus/leven-cli) - Measure the difference between two strings using the Levenshtein distance algorithm.
- [to-double-quotes](https://github.com/sindresorhus/to-double-quotes-cli) - Convert matching single-quotes to double-quotes.
- [to-single-quotes](https://github.com/sindresorhus/to-single-quotes-cli) - Convert matching double-quotes to single-quotes.
- [hget](https://github.com/bevacqua/hget) - Render websites in plain text from your terminal.
- [alex](https://github.com/wooorm/alex) - Catch insensitive, inconsiderate writing.
- [nasa-cli](https://github.com/xxczaki/nasa-cli) - Download NASA Picture of the Day.
- [trino](https://github.com/eneserdogan/trino) - Translation of words and phrases.
- [translate-shell](https://github.com/soimort/translate-shell) - Google Translate interface.

### Emoji

- [emoj](https://github.com/sindresorhus/emoj) - Find relevant emoji from text on the command-line.
- [emoji-finder](https://github.com/dematerializer/emoji-finder) - Quickly find and copy emoji to the clipboard via the command-line.
- [oji](https://github.com/xxczaki/oji) - Interactive text emoji maker.
- [gitmoji-cli](https://github.com/carloscuesta/gitmoji-cli) - Use emoji in commit messages.
- [gitmoji-changelog](https://github.com/frinyvonnick/gitmoji-changelog) - Generate gitmoji changelogs.

## Other Awesome Lists

- [awesome-command-line-apps](https://github.com/herrbischoff/awesome-command-line-apps#readme) – An alternative awesome list of cli apps.
- [awesome-macos-command-line](https://github.com/herrbischoff/awesome-macos-command-line#readme) - Shell commands and tools specific to macOS.
- [awesome-git-addons](https://github.com/stevemao/awesome-git-addons#readme) - Addons that extend git cli.
- [awesome-shell](https://github.com/alebcay/awesome-shell#readme) – Command-line utilities and frameworks.
- [terminals-are-sexy](https://github.com/k4m4/terminals-are-sexy#readme) – Terminal frameworks, plugins & resources.
- [awesome-zsh-plugins](https://github.com/unixorn/awesome-zsh-plugins#readme) – ZSH frameworks, plugins, tutorials & themes.
- [awesome-nodejs clis](https://github.com/sindresorhus/awesome-nodejs#command-line-apps) – Node.js modules and resources.

## License

[![CC0](https://i.creativecommons.org/p/zero/1.0/88x31.png)](https://creativecommons.org/publicdomain/zero/1.0/)

To the extent possible under law, [Adam Garrett-Harris](https://twitter.com/agarrharr) has waived all copyright and related or neighboring rights to this work.
